/* 
 * Thomas Pantzer: t_circle.cc, v0.1b  8.11.98 0:58 
 * 
 * 
 * Copyright 1998 by Thomas Pantzer
 * 
 * Permission to use, copy, modify, and distribute this software for noncommercial 
 * use and without fee is hereby granted, provided that the above copyright notice 
 * appear in all copies and that both that copyright notice and this permission 
 * notice appear in supporting documentation, and that the name of the Author not be 
 * used in advertising or publicity pertaining to distribution of the software 
 * without specific, written prior permission. The Author makes no representations about
 * the suitability of this software for any purpose.  It is provided "as is" 
 * without expressed or implied warranty. 
 * 
 * 
 * pantec@informatik.uni-leipzig.de   (Thomas Pantzer) 
 * 
 */

// Output from p2c 1.21alpha-07.Dec.93, the Pascal-to-C translator
// From input file "/home/pantec/src/objdraw/t_circle.p"




#define T_CIRCLE_G
#include "t_circle.h"



void t_circle::Init(t_colormap *c, t_vector2d *a, t_drawobj *n, double r, int lw)
{
  t_drawobj::Init(c, a, n, lw);

  radius = r;
  filled = false;
  kind = _circle;
}

void t_circle::SaveTo(int fd)
{
   t_drawobj::SaveTo(fd);

   char st[256];
   sprintf(st,"\trd:%g\tfl:%d",radius,filled);
   write(fd,st,strlen(st));
}


void t_circle::Draw(color_type ct)
{
//  int ox[3],oy[3],nx[3],ny[3];

  t_drawobj::Draw(ct);

  int x = anchor.GetX() - (int)(radius/2.0);
  int y = anchor.GetY() - (int)(radius/2.0);
  
  if (filled == true)
     {
      FillCircle(x,y,(int)radius);
     } 
   else
     {
      DrawCircle(x,y,(int)radius);  
     } 
}

/*  
  for (int i=0; i<73; i++)
    {
     double d,c,s;
     
     d = (double)i;
     d *= (M_PI/36.0);
     
     c = cos(d);
     s = sin(d); 
     
     for (int j=0; j<3; j++)
       {
        if ((width == 1) && (j != 1))
           continue;
           
        nx[j] = anchor.x + (int)(c * (radius+(j-1)));
        ny[j] = anchor.y + (int)(s * (radius+(j-1)));
       } 
     
     if (i > 0)
        for (int j=0; j<3; j++)
          {
           if ((width == 1) && (j != 1))
              continue;
              
           DrawLine(ox[j],oy[j],nx[j],ny[j]);
          }
          
     for (int j=0; j<3; j++)
       {     
        ox[j] = nx[j];
        oy[j] = ny[j];
       }    
    }
    
 */

// p2c: Note: Remember to call _t_circle_init() in main program [215]



// End.
