/* 
 * Thomas Pantzer: t_rectangle.cc, v0.1b  8.11.98 0:58 
 * 
 * 
 * Copyright 1998 by Thomas Pantzer
 * 
 * Permission to use, copy, modify, and distribute this software for noncommercial 
 * use and without fee is hereby granted, provided that the above copyright notice 
 * appear in all copies and that both that copyright notice and this permission 
 * notice appear in supporting documentation, and that the name of the Author not be 
 * used in advertising or publicity pertaining to distribution of the software 
 * without specific, written prior permission. The Author makes no representations about
 * the suitability of this software for any purpose.  It is provided "as is" 
 * without expressed or implied warranty. 
 * 
 * 
 * pantec@informatik.uni-leipzig.de   (Thomas Pantzer) 
 * 
 */

// Output from p2c 1.21alpha-07.Dec.93, the Pascal-to-C translator
// From input file "/home/pantec/src/objdraw/t_rectangle.p"
// #include <p2c/p2c.h>


#define T_RECTANGLE_G
#include "t_rectangle.h"

void t_rectangle::SaveMeToo(int fd)
{
   t_drawgrp::SaveMeToo(fd);

   char st[256];
   sprintf(st,"\tfl:%d",filled);
   write(fd,st,strlen(st));
}

void t_rectangle::EndP(t_vector2d *EP)
{
    t_line *line_[4];
    
    line_[0] = (t_line*)first;  
    line_[1] = (t_line*)line_[0]->next;  
    line_[2] = (t_line*)line_[1]->next;  
    line_[3] = (t_line*)line_[2]->next;  

    line_[0]->endpoint.Init(EP->GetX(),line_[0]->endpoint.GetY());
    line_[1]->anchor.Init(&line_[0]->endpoint);
    
    line_[1]->endpoint.Init(line_[1]->anchor.GetX(),EP->GetY());
    line_[2]->anchor.Init(&line_[1]->endpoint);
    
    line_[2]->endpoint.Init(line_[0]->anchor.GetX(),line_[2]->anchor.GetY());
    line_[3]->anchor.Init(&line_[2]->endpoint);
    
    line_[3]->endpoint.Init(&line_[0]->anchor);

    NewAnchor();
} 

void t_rectangle::Init(t_colormap *c, t_vector2d *a, t_drawobj *n,
		       t_vector2d *ep, int lw)
{
  t_vector2d *p[5];
  t_line *line_[5];

  t_drawgrp::Init(c, a, n, lw);
  count = 4;

  p[1] = new t_vector2d;
  p[3] = new t_vector2d;

  p[0] = a;
  p[1]->Init(ep->GetX(),a->GetY());

  p[2] = ep;
  p[3]->Init(a->GetX(),ep->GetY());
  p[4] = a;

  line_[4] = NULL;

  for (int i = 0; i < 4; i++)
     line_[i] = new t_line;

  for (int i = 0; i < 4; i++)
     line_[i]->Init(c, p[i], line_[i+1], p[i+1], lw);

  delete p[1];
  delete p[3];

  first = line_[0];
  filled = false;
  kind = _rectangle;
}

t_vector2d *t_rectangle::UL_Corner(void)
{
       return &first->anchor;
}

t_vector2d *t_rectangle::LR_Corner(void)
{
       return &first->next->next->anchor;
}


void t_rectangle::Fill(void)
{
       t_vector2d *pnt[4];    
   
       pnt[0] = &first->anchor;
       pnt[1] = &first->next->anchor;
       pnt[2] = &first->next->next->anchor;
       pnt[3] = &first->next->next->next->anchor;
   
       int x = pnt[0]->GetX();
       int y = pnt[0]->GetY();
       
       int w = pnt[1]->GetX() - pnt[0]->GetX();
       int h = pnt[2]->GetY() - pnt[1]->GetY();
       
       if ((w == 0) || (h == 0))
          {
           h = pnt[1]->GetY() - pnt[0]->GetY();
           w = pnt[2]->GetX() - pnt[1]->GetX();
          }
 
       if (w < 0)
          {
           x += w; 
           w = -w;
          } 
          
       if (h < 0)
          {
           y += h;
           h = -h;
          }   
       
       FillRectangle(x,y,w,h);
}


void t_rectangle::Draw(color_type ct)
{
#ifdef DEBUG
   fprintf(stderr, "t_rectangle::Draw()\n");    
#endif   
   t_drawgrp::Draw(ct);

   if (filled == true)
      Fill();
}

/*
void t_rectangle::Show(void)
{
   t_drawgrp::Show();

   if (filled == true)
      Fill();
}


void t_rectangle::Hide(void)
{
   t_drawgrp::Hide();

}
*/

void t_rectangle::Done()
{
    t_line *line_[4];
    
    line_[0] = (t_line*)first;  
    line_[1] = (t_line*)line_[0]->next;  
    line_[2] = (t_line*)line_[1]->next;  
    line_[3] = (t_line*)line_[2]->next;  
 
    for (int i=0; i<4; i++)
      {
//       fprintf(stderr,"rect.line[%d]->next: 0x%08lx\n",i+1,(long)line_[i]->next);
       delete line_[i];
      } 
      
    first = NULL;  
}

/*
void t_rectangle::MoveRel(t_vector2d *p)
{
    t_line *line_[4];
    
    line_[0] = (t_line*)first;  
    line_[1] = (t_line*)line_[0]->next;  
    line_[2] = (t_line*)line_[1]->next;  
    line_[3] = (t_line*)line_[2]->next;  
 
    for (int i=0; i<4; i++)
      line_[i]->MoveRel(p);
}
*/
// End.
