/* 
 * Thomas Pantzer: t_resistor.cc, v0.1b  8.11.98 0:58 
 * 
 * 
 * Copyright 1998 by Thomas Pantzer
 * 
 * Permission to use, copy, modify, and distribute this software for noncommercial 
 * use and without fee is hereby granted, provided that the above copyright notice 
 * appear in all copies and that both that copyright notice and this permission 
 * notice appear in supporting documentation, and that the name of the Author not be 
 * used in advertising or publicity pertaining to distribution of the software 
 * without specific, written prior permission. The Author makes no representations about
 * the suitability of this software for any purpose.  It is provided "as is" 
 * without expressed or implied warranty. 
 * 
 * 
 * pantec@informatik.uni-leipzig.de   (Thomas Pantzer) 
 * 
 */




#include "t_resistor.h"
#include <stdio.h>
//#include <strings.h>

void t_resistor::Init(t_colormap *c, class t_vector2d *a, char *name, double v)
{
   t_rectangle *R;
   t_line *L[2];
   t_vector2d X,Y,D;

   value = v;
   strcpy(identifier,name);

   Y.Init(a);
   D.Init(20,10);
   Y.Add(&D);
   t_drawgrp::Init(c,a,NULL,1);
   kind = _resistor;
   
   R = new t_rectangle;
   R->Init(c,a,NULL,&Y,1);

   Add(R);

   X.Init(a);
   Y.Init(a);
 
   D.Init(10,0);
   Y.Add(&D);

   for (int i=0; i<2; i++)
     {
      L[i] = new t_line;
      L[i]->Init(c,&X,NULL,&Y,1);
      
      if (i == 0)
         D.Init(-10,5);
       else
         D.Init(20,5);
      
      L[i]->MoveRel(&D);   
      Add(L[i]);
     }
}
   
void t_resistor::Show(void)
{
   t_drawgrp::Show();
   t_drawobj::Show();
}

void t_resistor::Hide(void)
{
   t_drawgrp::Hide();
   t_drawobj::Hide();
}


void t_resistor::Draw(void)   
{   
   char st[256];
   
   if ((1000.0 > value) && (value > 0))
      sprintf(st,"%3.1fR",value);
    else
      {  
       if ((1000000.0 > value) && (value > 1000.0))
          sprintf(st,"%3.1fk",value/1000.0);
        else
          sprintf(st,"%3.1fM",value/1000000.0);
      }
      
   OutTextXY(anchor.GetX(),anchor.GetY(),st);
}


