/* 
 * Thomas Pantzer: t_vector.h, v0.1b  8.11.98 0:58 
 * 
 * 
 * Copyright 1998 by Thomas Pantzer
 * 
 * Permission to use, copy, modify, and distribute this software for noncommercial 
 * use and without fee is hereby granted, provided that the above copyright notice 
 * appear in all copies and that both that copyright notice and this permission 
 * notice appear in supporting documentation, and that the name of the Author not be 
 * used in advertising or publicity pertaining to distribution of the software 
 * without specific, written prior permission. The Author makes no representations about
 * the suitability of this software for any purpose.  It is provided "as is" 
 * without expressed or implied warranty. 
 * 
 * 
 * pantec@informatik.uni-leipzig.de   (Thomas Pantzer) 
 * 
 */



#ifndef _T_VECTOR_H
#define _T_VECTOR_H

#include <math.h>

#define SQR(x)	fabs((x)*(x))
#define SIN_of(x)  sqrt(fabs(1.0 - SQR(x)))
#define DEG(x)    ((x * 180.0)/M_PI)

class t_vector2d {
public:

  void Init(int,int);
  void Init(double,double);
  void Init(t_vector2d *);
  
  void Add(t_vector2d *);
  void Sub(t_vector2d *);
  void Mult(double);
  void Neg(void);
  
  void Normalize(void);
  double Length(void);
  double Scalar(class t_vector2d *);
  double Cross(class t_vector2d *);
  double CosPhi(t_vector2d *v2);
  
  double Distance(t_vector2d *);
 
  void Turn(t_vector2d *);
  void Rotate(t_vector2d *M, t_vector2d &CSR);
  char Equal(t_vector2d *);
  
  int GetX(void);
  int GetY(void);
  
  void Print(void);
  
  t_vector2d* operator += (class t_vector2d *a)  { Add(a);  return this; };                         
  t_vector2d* operator -= (class t_vector2d *a)  { Sub(a);  return this; };                         
  t_vector2d* operator *= (double d)             { Mult(d); return this; };                         

  t_vector2d* operator / (double d)  
     { t_vector2d *v = new t_vector2d; 
       v->Init(this); 
       v->X /= d; 
       v->Y /= d;
       v->x = (int)v->X;
       v->y = (int)v->Y;
       return v; };

//  double operator * (class t_vector2d *a, class t_vector2d *b) { return a->Scalar(b); };
private:
  double X,Y;
  int x,y;
};


#endif
