

#define _T_SET_G
#include "t_Set.h"

#include <stdio.h>

#include "copyright.h"


//module definition and procedures go here

void t_Set::Init(unsigned int n)
{
      Flags = new unsigned char [(n / 8) +2];
      size = n;	 
}

void t_Set::Done(void)
{
      delete Flags;
}
      	 
void t_Set::Add(unsigned int p)
{
   if (Flags == NULL)
      return;

   if (p >= size)
      return;
      
   int hi = p / 8;   
   int lo = p % 8; 

   unsigned char mask = 1 << lo;

   Flags[hi] |= mask;
     
   elements++;
}

void t_Set::Del(unsigned int p)
{
   if (Flags == NULL)
      return;

   if (p >= size)
      return;
            
   int hi = p / 8;   
   int lo = p % 8; 

   unsigned char mask = 1 << lo;
   mask = 255 - mask;
   
   Flags[hi] &= mask;
     
   elements--;
}

char t_Set::Contains(unsigned int p)
{
   if (Flags == NULL)
      return false;

   if (p >= size)
      return false; 
      
   int hi = p / 8;   
   int lo = p % 8; 

   unsigned char mask = 1 << lo;
   
   if ((Flags[hi] & mask) > 0)
      return true;
    else
      return false;  
}

int t_Set::Index(unsigned int p)
{
   unsigned int k = 0;
   unsigned int i = 0;
   while ((k < p) && (i <= size))
     { 
      if (Contains(i) == true)
         k++;
      i++;   
     }    
        
   if (i > size)
      return -1;
      
   return i-1;      
}	 	 

int t_Set::Members(void)
{
   return elements;
}	 	 

void t_Set::Fill(void)
{
   for (unsigned int i=0; i<size; i++)
     Add(i);
}

void t_Set::Clear(void)
{
   for (unsigned int i=0; i<size; i++)
     Del(i);
}

void t_Set::Print(void)
{
   for (unsigned int k=0; k<size; k++)
     {
      int i = k / 8;
      int j = k % 8;
      char m = 1 << j;
        
      if ((Flags[i] & m) > 0)
         printf("1");
       else
         printf("_");  
     }  
}







