#include <unistd.h>
#include <time.h>

#include "forms.h"
#include "xfgc/xfbgi.h"
#include "stuff.h"
#include "minidraw.h"
#include "edit_objs.h"
#include "utils.h"

#include "drawobj/t_drawobj.h"
#include "drawobj/t_vector.h"

#include "copyright.h"


#ifdef WITH_SCANNER
   #include "xfscan.h"
//   #include "fbrowse.h"
   #include "t_scanner.h"
#endif

long lcnt =  0;
long t1,t2;


#ifdef DEBUG
void do_break(void)
{
	fprintf(stderr,"handmade breakpoint\n");
}	
#endif

void CanvasResize(void)
{
#ifdef WITH_SCANNER
       int h,w,d;
	       
       d = DisplayHeight(VScr.dpy,DefaultScreen(VScr.dpy));

       if (d > 100)  // we assume you have at least a 2x2-size desktop 
          Scanner.max_lines = (d * 3 * Matrix / 2) - 50;      // with your [FV|M|CT|OL]WM

       if (Scanner.__Image != NULL)
       	  {
	   w = Scanner.__Image->width;

#ifdef DEBUG
//	   do_break();
#endif

	   if (Scanner.scanned_size > 0)
	      h = __min(Scanner.__Image->height, Scanner.scanned_size / Scanner.__Image->bpl);
	    else
	      h = d - 50;
	  }
	else
	  {
	   w = Scanner._Width;
	   h = d - 50;
	  }   

	VScr.Resize(w / Matrix, h / Matrix);
	ScanOffset = 0;
	Update_Display(false);
#endif       
}




int idle_cb(XEvent *,void *)
{
   int c,i;
   char st[256];

#ifdef WITH_SCANNER
   if (Scanner.Callback() == true)
      {
//       fprintf(stderr,"idle_cb t%d f%d\n",true,false);
       //Update_Display(false);
       Bitmap2XImage(true);
       
       int height = Scanner.scanned_size / Scanner.__Image->bpl;
       sprintf(st,"% 5d",height);
       fl_set_object_label(fd_xfscan->sizebox,st);

       if (Scanner.working == false)
       	  {
//           Scanner.Stop();
           // fl_set_idle_callback(Dummy_cb,0);
           fl_set_idle_delta(10);
//           VScr.Store();
           CanvasResize();
           fl_activate_object(fd_xfscan->edit_bt);
//           fl_set_objlabel(fd_xfscan->start_bt,"Start/Stop"
           fl_set_button(fd_xfscan->start_bt,0);
	  	  }	
      } 

	usleep(10000);  
#endif

#ifdef DEBUG      
   t1 = time(0);  
   if (t1 != t2)
      {
       fprintf(stderr,"%ld loops\n",lcnt);
       lcnt = 0;
       t2 = t1;
      }
   lcnt++;   
#endif     

   return 0;
}



/* callbacks for form odraw */
void view_cb(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void input_cb(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  char st[256]; 
  int i;
    
  strcpy(st,fl_get_input(ob));
  
  switch (data)
    {
     case 0: //grid input
       if (sscanf(st,"%d",&i) == 1)
           grid = i;
       break;
       
     case 1: // font input
       break;
    }
    
  ActualObj =  NULL;
  RootObj.SelectAll(false);
}

void slider_cb(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  double d;
  char st[256];
  
  d = fl_get_slider_value(ob);
  
  switch (data)
    {
     case 0: //grid 
       grid = (int)d;
       sprintf(st,"%d",grid);     
       fl_set_input(fd_odraw->grid_inp,st);
       break;
       
     case 1: // font 
       break;
    }

  ActualObj =  NULL;
  RootObj.SelectAll(false);
}



void mouse_handler(XEvent *ev)
{
  char update;
  t_vector2d M,V,X,*ul,*br;

  update = false;
  M.Init(ev->xbutton.x,ev->xbutton.y);
  
  char st[256];
  
  sprintf(st,"% 4d , % 4d",M.GetX()/grid,M.GetY()/grid);
  fl_set_input(fd_odraw->coord_inp,st);


  switch(cutmode)
    {
     case begin:
      switch (ev->type)                  
        {
	 case ButtonPress:
	   CutRect.Init(CutRect.cmap,&M,NULL,&M,3);
	   CutRect.OpaqueAll(true);
	   cutmode = upper;
           fl_set_cursor(FL_ObjWin(VScr.fd_xfbgi->canvas), XC_bottom_right_corner);
	   CutRect.Show();
	   return;
	} 
       break;
       
     case upper:
      switch (ev->type)                  
        {
	 case MotionNotify:
	   CutRect.Hide();
	   CutRect.EndP(&M);
	   CutRect.Show();
	   return;
	   
	 case ButtonRelease:
	   cutmode = lower;
	   CutRect.Hide();
//	   VScr.SetWriteMode(CopyPut);
	   return;
	} 
       break;

     case lower:
	fl_set_button(fd_xfscan->cut_bt,0);
        fl_set_cursor(FL_ObjWin(VScr.fd_xfbgi->canvas),-1);
        cutmode = end;
	if (Scanner.__Image == NULL)
	   return;
	   
	ul = CutRect.UL_Corner();  
	br = CutRect.LR_Corner();  
	
	Scanner.__Image->Cut(ul->GetX()*Matrix,ul->GetY()*Matrix,
	                     br->GetX()*Matrix,br->GetY()*Matrix);   	
	CanvasResize();	
	return;
	
     case end:  
     case uninitialized:
     default:
       break;
    }

  if (addingtext == true)
     {
//      fprintf(stderr,"addingtext\n");
      switch (ev->type)                  
        {
         case KeyPress:
         case KeyRelease:
//           fprintf(stderr,"key press/release\n");
           update = AddText(ev,&CursorObj.anchor); 	   
           break;
           

         case ButtonRelease:
      	   switch (ev->xbutton.button)
             {
              case 3:  // 
                Update_Display(true);
                if (VScr.fd_xfbgi->xfbgi->visible == 0)
                   fl_show_form(VScr.fd_xfbgi->xfbgi,FL_PLACE_CENTERFREE,FL_FULLBORDER,"xfscan");
                 else  
                   fl_raise_form(VScr.fd_xfbgi->xfbgi);
   
                fl_raise_form(fd_odraw->odraw);
                break;    
             }
           return;
           break;  
 
         default:
           // addingtext = false;
           return;
           break;  
        }   
     } 
    
  switch (ev->xbutton.button)
    {
     case 0:
/*
          {
           RootObj.SetSelected(true,&CursorObj);
           CursorObj.Hide();
           V.Init(&CursorObj.anchor); 
           CursorObj.Init(grid*(M.x / grid),grid*(M.y/grid));
       
           CursorObj.Show();
           if (V.Equal(&CursorObj.anchor) == true)
              return;
          }
*/
//       if (ev->type == MotionNotify)          
       {
        V.Init(&CursorObj.anchor); 
        X.Init(grid*((M.GetX()/grid)+1),grid*((M.GetY()/grid)+1));
        CursorObj.MoveTo(&X);
        if (V.Equal(&CursorObj.anchor) == true)
           return;
       }    
//       break;
           
     case 1:  // left
       {
#ifdef WITH_SCANNER
        if (fl_get_button(fd_xfscan->edit_bt) == 0)
           {
//       fprintf(stderr,"edit mode\n");
            return;
           } 
#endif           
       switch (EditMode)
         {
          case 0: // normal  (add)
            {
             switch(ObjMode)
               {
                case 0:	
                  update = Add_Object(ev->type,&CursorObj.anchor,_line);      
                  break; 
                  
                case 1:	
                  update = Add_Object(ev->type,&CursorObj.anchor,_circle);    
                  break; 

                case 2:	
                  update = Add_Object(ev->type,&CursorObj.anchor,_rectangle); 
                  break; 
                  
                case 3:	
                  update = AddText(ev,&CursorObj.anchor); 	   
                  //  addingtext = true;
                  break;
                  
                case 4:
                  update = Add_Object(ev->type,&CursorObj.anchor,_resistor);
                  break;       
                  
                case 6:
                  update = Add_Object(ev->type,&CursorObj.anchor,_polygon);
                  break;  
               } // switch (ObjMode)
            }  
            break; // case insert	
                 
          case 1: // delete
            Delete_Obj(ev->type,&CursorObj.anchor);
            break; 
                 
          case 2: // rotate
            Rotate_Obj(ev->type,&CursorObj.anchor);
            break; // case rotate
                 
          case 3:  // move
            update = Move_Obj(ev->type,&CursorObj.anchor);
            break;  // case move    
            
          case 4:  // mirror
            break;
               
          case 5: // update
            break;
            
          case 6: // mark
            break;
            
          case 7: // group
            Group_Obj(ev->type,&CursorObj.anchor);  
            break;      
          
          case 8:
            Upper_Obj(ev->type,&CursorObj.anchor);  
            break;
            
          case 9:
            Save_Obj(ev->type,&CursorObj.anchor);
            break;  
         
         } // switch (EditMode)
       }
       break;
           
     case 2:  // middle (always move)
       {
//        ScanOffset = 0;
//        Move_Obj(ev->type,&M);
       }
       break;
           
     case 3:  // 
       {
//        Rotate_Obj(ev->type,&M);
#ifdef WITH_SCANNER
//        ScanOffset = 0;
//        Update_Display(true);
        update = true;
        
	if (fd_xfscan->xfscan->visible == 0)
           fl_show_form(fd_xfscan->xfscan,FL_PLACE_CENTERFREE,FL_FULLBORDER,"xfscan");
         else  
           fl_raise_form(fd_xfscan->xfscan);
#endif
        fl_raise_form(fd_odraw->odraw);
       }
       break;    
    }

  if (ev->type == ButtonRelease)
     {
      if (ObjMode != 6)  // _polygon
         ActualObj = NULL;
       else
         {
          if (update == true)
             ActualObj = NULL;
         }
//      update = true;
     } 

  if (update == true)
     {
       ScanOffset = 0;
       RootObj.SelectAll(false);
       RootObj.OpaqueAll(false);
       Update_Display(true);
     } 
  
//  fprintf(stderr,"mousebutton %d event %d at (%d,%d)\n",
//         ev->xbutton.button,ev->type,
//         ev->xbutton.x,ev->xbutton.y);  
     
  return;       
}

int canvas_mouse(FL_OBJECT *ob, Window _win, int w, int h, XEvent *ev, void *d)
{
  switch (ev->type)
    { 
     case KeyPress:
     case KeyRelease:
     case ButtonPress:
     case ButtonRelease:
     case MotionNotify:
       mouse_handler(ev);
       break;
    }

  return 0;
}



void Raise_forms(void)
{
	if (fl_get_button(fd_xfscan->raise_bt) == 0)
	   return;
	   
	if (fd_xfscan->xfscan->visible)
	   fl_raise_form(fd_xfscan->xfscan);	   		

        if (VScr.fd_xfbgi->xfbgi->visible == 0)
           VScr.Show(FL_PLACE_CENTERFREE);
         else  
           fl_raise_form(VScr.fd_xfbgi->xfbgi);

	if (fd_odraw->odraw->visible)
	   fl_raise_form(fd_odraw->odraw);	   		
} 


/* callbacks for form xfscan */
void button_cb(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
	Raise_forms();

  int i = fl_get_button(ob);
  
  addingtext = false;
  
  switch(data)
    {
     case -1:
#ifdef WITH_SCANNER
       Main_ExitProc(0);
#endif       
       break;
       
     case 1: // start/stop scan
#ifdef WITH_SCANNER
       if (Scanner.working == true)
          {
           Scanner.Stop();
           // fl_set_idle_callback(Dummy_cb,0);
//           fl_set_idle_delta(10);
//           VScr.Store();
           CanvasResize();
           fl_activate_object(fd_xfscan->edit_bt);
//           fl_set_objlabel(fd_xfscan->start_bt,"Start/Stop"
          } 
        else
          {
           ScanOffset = 0; 
           fl_deactivate_object(fd_xfscan->edit_bt);
           fl_set_idle_callback(idle_cb,0);
//           fl_set_idle_delta(0);
		   fl_set_idle_delta(10);
           
           int k = fl_get_choice(fd_xfscan->dpi_ch);
           Scanner.Start(k);
//           int j = Scanner.SetMode(k);    
//           fprintf(stderr,"req./set: %d/%d\n",k,j);
          }  
#endif          
       break;
       
     case 2: // edit mode
#ifdef WITH_SCANNER
       if (i == 1)
          {
           fl_show_form(fd_odraw->odraw,FL_PLACE_CENTER,FL_FULLBORDER,"xfscan edit"); 
           fl_deactivate_object(fd_xfscan->start_bt);
//           Scanner.Done();
          } 
        else
          {
	   if (fd_odraw->odraw->visible == true)
              fl_hide_form(fd_odraw->odraw);  
	      
           fl_activate_object(fd_xfscan->start_bt);
           RootObj.SelectAll(false);
           Update_Display(true);
//           Scanner.GetMode();
          } 
#endif          
       break;
       
     case 3: // browser
#ifdef WITH_SCANNER
	{
	 int save_mode = fl_get_choice(fd_xfscan->mode_mnu)-1;  
	 const char *fext = fl_get_choice_text(fd_xfscan->mode_mnu);
	 const char *fn = fl_show_fselector("save file", SHARES_PATH "/images" , fext ,"");

	 if (fn != NULL)
	    filesave_cb(fn,save_mode);
	}					

/*
       read_files_to_browser(current_dir);
       
       if (fd_file_br->browser->visible != 0)
          fl_raise_form(fd_file_br->browser);
        else  
          fl_show_form(fd_file_br->browser,FL_PLACE_MOUSE,FL_FULLBORDER,"xfdrc load");
*/
#endif
       break;
       
     case 4: // turn image
       Scanner.Rotate();
       CanvasResize();
       break;
       
     case 5: // mirror image
       Scanner.Mirror();
       CanvasResize();
       break;	
       
     case 6: // cut image
       switch(cutmode)
	 {
	  t_vector2d P;

	  case uninitialized:
	    P.Init(-800,-800);
	    CutRect.Init(&CM[0],&P,NULL,&P,1);
	  case end:
	    cutmode = begin;
	    break;
	    
	  case begin:
	  case upper:
	  case lower:
	  default:
	    fl_set_cursor(FL_ObjWin(VScr.fd_xfbgi->canvas),-1);
            cutmode = end;
	    break;
	 }
       break;  
       
     case 7: // get mode
#ifdef WITH_SCANNER
       if (Scanner.GetMode() == true)
          {
           char st[256];
           strcpy(st,Scanner.type.model);
           fl_set_object_label(fd_xfscan->textbox,st);
          }
#endif
       break;  
       
     case 13:
       i = fl_show_colormap(CM[color_map].normal);
#ifdef DEBUG
       fprintf(stderr,"color [%d] selected (default %d)\n",i,CM[color_map].normal);  
#endif       
       {
         int j = 0;
#ifdef DEBUG
         fprintf(stderr,"N/H/S:%d/%d/%d\n",CM[0].normal,
                                           CM[0].hidden,
                                           CM[0].selected);
#endif
         while (!(
               (CM[j].normal == 0) &&
               (CM[j].hidden == 0) &&  
               (CM[j].selected == 0)
               ))
           {
#ifdef DEBUG
            fprintf(stderr,"CM[%d].normal = %d\n",j,CM[j].normal); 
#endif            
            if (i == CM[j].normal)
               {
#ifdef DEBUG
                fprintf(stderr,"found in table at pos  [%d]\n",j);
#endif                
                break; 
               } 

            j++;
           }    

         if (j >= 64)
            return;
            
         if ((CM[j].normal == 0) && (CM[j].hidden == 0) && (CM[j].selected == 0))
            {
#ifdef DEBUG
             fprintf(stderr,"about to add %d at pos  [%d]\n",i,j);
#endif             
             CM[j].hidden = FL_BLACK;
             CM[j].selected = FL_WHITE;
             CM[j].normal = i;
            }

         color_map = j;  
       }
       break;  
    }
}



void choice_cb(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  int i,j,arg;

	Raise_forms();
  
  arg = fl_get_choice(ob)-1;
  addingtext = false;
  
  switch (data)
    {
     case 10:	// add choice
       ObjMode = arg;
       fl_set_choice(fd_odraw->edit_ch,1);
       EditMode = 0;
       break;

     case 11:	// edit choice
       EditMode = arg;
       break;
       
     case 12:	// delete
       break;  
       
//     case 13:	// color
//       color_map = arg;
//       break;
     
     case 14:	// fillstyle
       FillStyle = arg;
       break;
      
     case 15:	// linewidth
       if (arg == 0)
          VScr.LineWidth = 1;
        else
          VScr.LineWidth = 3;  
       break;
       
     case 16:	// grid
       break;           

     case 17: // font
       VScr.TextFont = arg;
       break;



     case 0: // size
#ifdef WITH_SCANNER
       Matrix = 1 + arg;
//       fprintf(stderr,"setting matrix to %d\n",Matrix);
       CanvasResize(); 
#endif
       break;
       
     case 1: // mode
       {
#ifdef WITH_SCANNER
        if (Scanner.GetMode() == true)
           printf("%ddpi,%dbit,%ddepth\n",Scanner.mode.xdpi,Scanner.mode.sc_mode,Scanner.mode.depth);
          
        j = Scanner.SetMode(arg+1);    
//#ifdef DEBUG
        printf("mode requested/set: %d/%d\n",arg,j);
//#endif
          {
           char st[256];
           strcpy(st,Scanner.type.manufacturer);
           strcat(st,"  ");
           strcat(st,Scanner.type.model);
           fl_set_object_label(fd_xfscan->textbox,st);
          }
#endif
        CanvasResize(); 
       }
       break;
    }

#ifdef DEBUG    
  fprintf(stderr,"choice result is %d\n",arg);  
#endif

  ActualObj =  NULL;
//  RootObj.SetSelected(false);
}



int preemptive_handler(FL_OBJECT *ob, int event,
         FL_Coord mx, FL_Coord my, int key, void *xev)         
{      
	if (event == FL_LEAVE)
	   {
//          fl_set_graphics_mode (gmode[4].mode, 0); 
	    fl_set_cursor(FL_ObjWin(ob),-1);
	    return 0;
	   }
      		
	if (event != FL_ENTER)
	   return 0;
      
	switch (cutmode)
	  {
	   case begin:
             fl_set_cursor(FL_ObjWin(ob), XC_top_left_corner);
	     return 0;
	   
	   case upper:  		     	
             fl_set_cursor(FL_ObjWin(ob), XC_bottom_right_corner);
	     return 0;	
	     
	   default:
	     break;  
	  }

#ifdef WITH_SCANNER
	if (fl_get_button(fd_xfscan->edit_bt) == 0)
	   return 0;
#endif      

        switch (EditMode)
          {
           case 0:
             switch(ObjMode)
                {
                 case 0: 
		   fl_set_cursor(FL_ObjWin(ob), XC_pencil); 
		   return 0;

                 case 1:
//                   fl_set_cursor(FL_ObjWin(ob), XC_rtl_logo);
                   break;
                   
                 case 2: 
		   fl_set_cursor(FL_ObjWin(ob), XC_iron_cross); 
		   return 0;
		   
                 case 3: 
		   fl_set_cursor(FL_ObjWin(ob), XC_xterm); 
		   return 0;
                }
             break;
                 
           case 1: // delete
             fl_set_cursor(FL_ObjWin(ob), XC_pirate);
             break;
           case 2: // rotate
             fl_set_cursor(FL_ObjWin(ob), XC_box_spiral);
             break;

           case 6: // group
             fl_set_cursor(FL_ObjWin(ob), XC_spider);
             break;
    
           case 7: // upper 
           case 3: // move
             fl_set_cursor(FL_ObjWin(ob), XC_hand2);
             break;
             
           default:
             fl_set_cursor(FL_ObjWin(ob), XC_question_arrow);
             break;  
          } 
   
   return 0;  
}

/*
int post_handler(FL_OBJECT *ob, int event,
          FL_Coord mx, FL_Coord my, int key, void *xev)
{
    char *s = 0;

          if(ob == fd_panel->run_btn)       s = "execute user\ncallbacks";
     else if(ob == fd_panel->save_cfg_btn)  s = "not omplemented"; 
     else if(ob == fd_panel->robot_cnt_mnu) s = "set number of\nused robots"; 
     else if(ob == fd_panel->select_mnu)    s = "set shown robot"; 
     
     else if(ob == fd_panel->mode_mnu)      s = "switch between\npiped and real mode";
      
     else if(ob == fd_panel->demo_mnu)      s = "select operation\nmode for demo"; 
     else if(ob == fd_panel->gr_arm_sl)     s = "set angle for\ngrip arm"; 
     else if(ob == fd_panel->turn_dl)       s = "turn robot\nto direction"; 
     else if(ob == fd_panel->dev_inp)       s = "specify\nserial line"; 
     else if(ob == fd_panel->file_btn)      s = "not imlemented"; 
     else if(ob == fd_panel->filename_inp)  s = "enter filename\nfor snns-network"; 

     else if(ob == fd_panel->move_btn[0]) s = "move robot\ncounterclockwise"; 
     else if(ob == fd_panel->move_btn[1]) s = "move robot\nforward"; 
     else if(ob == fd_panel->move_btn[2]) s = "move robot\nclockwise"; 
     else if(ob == fd_panel->move_btn[3]) s = "turn robot\ncounterclockwise"; 
     else if(ob == fd_panel->move_btn[4]) s = "turn robot\nclockwise"; 
     else if(ob == fd_panel->move_btn[5]) s = "move robot\nclockwise back"; 
     else if(ob == fd_panel->move_btn[6]) s = "move robot\nbackward"; 
     else if(ob == fd_panel->move_btn[7]) s = "move robot\ncounterclockwise\nback"; 

     else if(ob == fd_panel->grip_btn)  {
                                         if (fl_get_button(ob))
                                               s= "open the grip";
                                            else   
                                               s= "close the grip";
                                        }
     else                               s= "Want to quit ?\nPress me";

     if(event == FL_ENTER && s)
        fl_show_oneliner(s, ob->form->x + ob->x + 20,
                        ob->form->y + ob->y + ob->h);
     else if(event != FL_MOTION)
       fl_hide_oneliner();

     return 0;
}
*/
